EdiraCostMatrix <-
function(x, maxk, estseg){
    if (!is.numeric(x) || !(is.vector(x) || is.matrix(x))) 
        stop("'x' must be a numeric vector or matrix.")
    if (is.vector(x)) {
        r <- x
        q <- x * x
        d <- 1
    }
    else {
        r <- rowSums(x)
        q <- rowSums(x * x)
        d <- ncol(x)
    }
    n <- length(r)
    if (!is.numeric(maxk) || (length(maxk) != 1) || (maxk < 2) || 
        (maxk > n)) 
        stop(sprintf("'maxk' must be a single number between 2 and the number of rows of 'x': %d.", 
            n))
    cr <- cumsum(r)
    cq <- cumsum(q)
    G <- matrix(as.numeric(NA), nrow = maxk, ncol = n)
    if(estseg=="median"){
        sortiert <- sort(r, index.return = TRUE)
        for (k in seq(1,ceiling((maxk - 1)/2)*2-1,2)) {
            i <- 1:(n - k)
            j <- 2:(n - k + 1)    
            cqk <- cq[i + k] - cq[i]
            crk <- cr[i + k] - cr[i]
            sortieren_matrix <- matrix(c(rep(c(1:k,rep(0,n-k+1)),n-k),1:k), nrow = (n-k+1), ncol = n, byrow=TRUE)
            index_alles <- t(sortieren_matrix[,sortiert$ix])           
            index <- matrix(index_alles[index_alles!=0], ncol=ncol(index_alles))
            i <- c(0,i)
            mediane <- r[i+index[ceiling(k/2),]]
            G[k, c(1,j)] <- c(cq[k],cqk) - 2*mediane*c(cr[k],crk)+k*mediane^2
        }
        if(maxk > 2){
            for (k in seq(2,floor((maxk - 1)/2)*2,2)) {
                i <- 1:(n - k)
                j <- 2:(n - k + 1)    
                cqk <- cq[i + k] - cq[i]
                crk <- cr[i + k] - cr[i]
                sortieren_matrix <- matrix(c(rep(c(1:k,rep(0,n-k+1)),n-k),1:k), nrow = (n-k+1), ncol = n, byrow=TRUE)
                index_alles <- t(sortieren_matrix[,sortiert$ix])           
                index <- matrix(index_alles[index_alles!=0], ncol=ncol(index_alles))
                i <- c(0,i)
                mediane <- (r[i+index[k/2,]]+r[i+index[k/2+1,]])/2
                G[k, c(1,j)] <- c(cq[k],cqk) - 2*mediane*c(cr[k],crk)+k*mediane^2
            }
        }
        index_k_alles <- c(1:maxk,numeric(n-maxk))[sortiert$ix]
        index_k <- index_k_alles[index_k_alles!=0]
        if(maxk %% 2 == 1){median_k <- r[index_k[ceiling(maxk/2)]]} else {median_k <- (r[index_k[maxk/2]] + r[index_k[maxk/2+1]])/2}
        G[maxk, 1] <- cq[maxk] - 2*median_k*cr[maxk]+maxk*median_k^2
    }  
    if(estseg=="mean"){
    k = 1:maxk
    G[, 1] = cq[k] - cr[k] * cr[k]/(k * d)
        for (k in 1:(maxk - 1)) {
            i <- 1:(n - k)
            j <- 2:(n - k + 1)    
            cqk <- cq[i + k] - cq[i]
            crk <- cr[i + k] - cr[i]
            G[k, j] <- cqk - crk * crk/(k * d)
        }    
    }
    return(G)
}
