EdiraSegment <- 
function (y, maxseg, maxk, estseg){
    if (!is.matrix(y)) 
        y = matrix(y, ncol = 1)
    n = nrow(y)
    maxseg = as.integer(maxseg)
    maxk = as.integer(maxk)
    if (!((length(maxseg) == 1) && !is.na(maxseg) && (maxseg <= 
        n))) 
        stop(sprintf("maxseg must be an integer of length 1 between 1 and nrow(y)=%d", 
            n))
    if (!((length(maxk) == 1) && !is.na(maxk) && (maxk <= n))) 
        stop(sprintf("maxk must be an integer of length 1 between 1 and nrow(y)=%d", 
            n))
    verbose = as.integer(0)
    G = EdiraCostMatrix(y, maxk, estseg)
    fs = .Call("findsegments", G, maxseg, verbose, PACKAGE = "tilingArray")
    bp = vector(mode = "list", length = nrow(fs$th))
    for (i in seq(along = bp)) {
        stopifnot(fs$th[i, i] == n + 1)
        bp[[i]] = cbind(estimate = fs$th[i, 0:(i - 1)])
    }
    new("segmentation", y = y, x = numeric(0), flag = integer(0), 
        breakpoints = bp, logLik = fs$J, hasConfint = rep(FALSE, 
            length(bp)))
}
