edira_ratios <- function(A, B, references=NULL){
    if(references != "both"){
    if(min(B$data) >= 0){stop("Please check whether B$data contains copy number ratio data on the log2 scale as required.")}
    }
    if(length(references) == 0){stop("Please specify whether the data input was generated using reference samples or not.")}
    rowwise_mean <- function(x){
            apply(x,1,mean)
        }
    if(references=="none"){
    references <- "only A" 
    }
    if(references=="only A"){
        a.norm_med <- rowwise_mean(A$data)
        b.norm_med <- rowwise_mean(B$data)
        vorzeichen_a <- sign(a.norm_med)
        
        rowwise_weighted_mean <- function(x){
            weight_a <- sd(a.norm_med)/sd(b.norm_med)
            weight_b <- 1
            weighted.mean(x,w=c(weight_a,weight_b))
        }
        if(sd(a.norm_med) >= sd(b.norm_med)){
            meds <- rbind(a.norm_med,vorzeichen_a*abs(b.norm_med))
            b_norm_data <- B$data - apply(meds,2,rowwise_weighted_mean) 
        }
        if(sd(a.norm_med) < sd(b.norm_med)){
            b_norm_data <- B$data - b.norm_med
        }
        B$data <- B$data - rowwise_mean(b_norm_data)
    }
    eccc_pos <- function(pos) {
        if (all(nrow(A$data) != nrow(B$data))) {
            stop("A$data and B$data must have the same number of rows.")
        }
        y_ratio <- as.numeric(A$data[pos,])
        x_ratio <- as.numeric(B$data[pos,])
        SAR <- function(x){sqrt(sum(x^2))}        
        eccc <- (y_ratio * x_ratio)/(SAR(x_ratio) * SAR(y_ratio))
        ymed <- log2(median(2^as.numeric(y_ratio)))
        xmed <- log2(median(2^as.numeric(x_ratio)))
        eccc_sum <- sum(eccc)
        if(eccc_sum > 0){
            if(ymed > 0 & xmed > 0 | ymed >= 0 & xmed > 0 | ymed > 0 & xmed >= 0){quadrant <- 1} else {
                if(ymed < 0 & xmed < 0 | ymed <= 0 & xmed < 0 | ymed < 0 & xmed <= 0){quadrant <- 3} else {quadrant <- sample(c(1,3),1)}
            }            
        } else {
            if(ymed > 0 & xmed < 0 | ymed >= 0 & xmed < 0 | ymed > 0 & xmed <= 0){quadrant <- 2} else {
                if(ymed < 0 & xmed > 0 | ymed <= 0 & xmed > 0 | ymed < 0 & xmed >= 0){quadrant <- 4} else {quadrant <- sample(c(2,4),1)}
            }
        } 
        
        test <- wilcox.test(eccc, alternative = "greater")$p.value
        as.data.frame(list(eccc = eccc_sum, test = test, quadrant=quadrant))
    }
    alleWerte <- cbind(t(sapply(1:nrow(A$data), eccc_pos)))
    probier <- apply(alleWerte, 2, as.numeric)
    out <- as.data.frame(cbind(A$info, as.data.frame(probier)))
    class(out) <- "edira_ratios"
    out
}
