find_regions <-
function (results, chr = 1:22, resolution = 10^6, level = 0.05, 
    length_penalty = 4, limit = 10^(-3), min_prop = 0.01, min_med_num = 1, 
    combine_near = 1, eliminate_short = 1, num_regions = 100, 
    genomwide = TRUE){
    if (limit >= level) {
        stop("It must be limit < level.")
    }
    welche_chr <- as.numeric(labels(table(results$chromosome))[[1]])
    gib_chr <- function(i) {
        range(which(results$chromosome == i))[1]
    }
    anf <- sapply(welche_chr, gib_chr)
    xwerte <- results$position
    for (m in welche_chr[-1]) {
        xwerte[results$chromosome == m] <- xwerte[results$chromosome == 
            m] + xwerte[anf[m] - 1]
    }
    rechtsgrenze <- range(xwerte)[2]/resolution
    if (genomwide == FALSE) {
        data(cytoband)
        q_ende <- cytoband$end[c((which(cytoband$start == 0) - 
            1)[-1], length(cytoband$end))]/10^6
        gib_chr_bereich <- function(chr1) {
            spannw <- range(results$position[results$chromosome == 
                chr1])/10^6
            spannw[2] - spannw[1]
        }
        insges <- sum(sapply(chr, gib_chr_bereich))
        prop <- insges/cumsum(q_ende)[22]
        min_prop <- min_prop/prop
    }
    find_regions_chr <- function(results, chr1, resolution, level, 
        length_penalty, limit, min_prop, min_med_num, combine_near, 
        eliminate_short, num_regions) {
        punkte <- function(a, b, q) {
            welche <- which(results$chromosome == chr1)
            pos <- results$position[welche]
            drin <- which(pos >= a * resolution & pos < b * resolution)
            quad <- which(results$quadrant[welche][drin] == q)
            tests <- results$test[welche][drin][quad]
            sum(-log(tests[tests < level]))
        }
        relevant <- function(a, b, q) {
            welche <- which(results$chromosome == chr1)
            pos <- results$position[welche]
            drin <- which(pos >= a * resolution & pos < b * resolution)
            quad <- which(results$quadrant[welche][drin] == q)
            tests <- results$test[welche][drin][quad]
            num_regions_tests_std <- sum(results$test[results$quadrant == 
                q] < level)
            (length(which(tests < limit))/num_regions_tests_std)
        }
        enthalten1 <- function(a, q) {
            welche <- which(results$chromosome == chr1)
            pos <- results$position[welche]
            drin <- which(pos >= a * resolution & pos < (a + 
                1) * resolution)
            quad <- which(results$quadrant[welche][drin] == q)
            tests <- results$test[welche][drin][quad]
            length(which(tests < level))
        }
        enthalten <- function(a, b, q) {
            welche <- which(results$chromosome == chr1)
            pos <- results$position[welche]
            drin <- which(pos >= a * resolution & pos < b * resolution)
            quad <- which(results$quadrant[welche][drin] == q)
            tests <- results$test[welche][drin][quad]
            enthalten2 <- function(x) {
                enthalten1(x, q)
            }
            einzeln_enthalten <- sapply(a:(b - 1), enthalten2)
            median(einzeln_enthalten)
        }
        subdiag <- function(l) {
            x <- matrix(1:l^2, ncol = l)
            out <- diag(x) + 1
            out[-length(out)]
        }
        max_abstand <- function(a, b, q) {
            welche <- which(results$chromosome == chr1)
            pos <- results$position[welche]
            drin <- which(pos >= a * resolution & pos < b * resolution)
            quad <- which(results$quadrant[welche][drin] == q)
            tests <- results$test[welche][drin][quad]
            positionen <- results$position[welche][drin][quad]
            temp <- outer(positionen, positionen, "-")
            max(temp[subdiag(nrow(temp))])
        }
        #grenze_rechts <- round((sort(results.edira$position[results.edira$chromosome == chr1])[length(results.edira$position[results.edira$chromosome == chr1])]-sort(results.edira$position[results.edira$chromosome == chr1])[1])/resolution)
        grenze_rechts <- round(range((results$position[results$chromosome == 
            chr1] - results$position[results$chromosome == chr1][1])/resolution)[2])
        werte1 <- werte3 <- matrix(numeric((grenze_rechts + 1)^2), 
            nrow = grenze_rechts + 1)
        for (i in seq(0, grenze_rechts, 1)) {
            punkte1_b <- function(j) {
                punkte(i, j, 1)
            }
            punkte3_b <- function(j) {
                punkte(i, j, 3)
            }
            werte1[i, seq(i + 1, grenze_rechts + 1, 1)] <- sapply(seq(i + 
                1, grenze_rechts + 1, 1), punkte1_b)
            werte3[i, seq(i + 1, grenze_rechts + 1, 1)] <- sapply(seq(i + 
                1, grenze_rechts + 1, 1), punkte3_b)
        }
        beste <- array(numeric((ncol(werte1) - 1) * 4 * num_regions), 
            dim = c((ncol(werte1) - 1), 4, num_regions))
        sperre <- NULL
        intervalle <- matrix(numeric(num_regions * 3), nrow = 3)
        uebrig_x <- 1:(ncol(werte1) - 1)
        for (i in 1:num_regions) {
            for (j in (ncol(werte1) - 1):1) {
                zeile_mehrfach <- NULL
                folgeZeile <- 1:nrow(werte1)
                if (i > 1) {
                  zeilen <- 1:(ncol(werte1) - 1)
                  uebrig_x <- zeilen[intersect(which((zeilen + 
                    j) %in% 1:(ncol(werte1))), intersect(which((zeilen %in% 
                    sperre) == FALSE), which(((zeilen + j) %in% 
                    sperre) == FALSE)))]
                  if (length(uebrig_x) > 0) {
                    for (n in length(uebrig_x):1) {
                      if (uebrig_x[n] + j <= (ncol(werte1))) {
                        intervall <- uebrig_x[n]:(uebrig_x[n] + 
                          j)
                        if (any(sperre %in% intervall)) {
                          uebrig_x <- uebrig_x[-n]
                        }
                      }
                    }
                  }
                  folgeZeile <- uebrig_x
                }
                folgeSpalte <- folgeZeile + j
                ind <- nrow(werte1) * (folgeSpalte - 1) + folgeZeile
                werte1_ind <- werte1[ind][is.na(werte1[ind]) == 
                  FALSE]
                if (length(werte1_ind) > 0 & sum(werte1_ind != 
                  0) > 0) {
                  Max1 <- max(werte1_ind[werte1_ind != 0])
                }
                else {
                  Max1 <- -1
                }
                werte3_ind <- werte3[ind][is.na(werte3[ind]) == 
                  FALSE]
                if (length(werte3_ind) > 0 & sum(werte3_ind != 
                  0) > 0) {
                  Max3 <- max(werte3_ind[werte3_ind != 0])
                }
                else {
                  Max3 <- -1
                }
                if (Max1 >= Max3) {
                  Max <- Max1
                  werte <- werte1
                  quadrant <- 1
                }
                else {
                  Max <- Max3
                  werte <- werte3
                  quadrant <- 3
                }
                max_wert <- which(werte == Max)
                das <- max_wert[max_wert %in% ind]
                zeile <- das%%ncol(werte)
                spalte <- ceiling(das/ncol(werte))
                if (length(zeile) > 1) {
                  zeile_mehrfach <- c(zeile_mehrfach, j)
                  nimm <- round(median(1:length(zeile)))
                  zeile <- zeile[nimm]
                  spalte <- spalte[nimm]
                }
                if (length(c(zeile, spalte)) > 1) {
                  beste[j, c(1:2, 4), i] <- c(zeile, spalte, 
                    quadrant)
                }
            }
            gib_beste <- function(j) {
                zaehler <- 0
                if (beste[j, 1, i] != 0 & beste[j, 2, i] != 0) {
                  for (k in (1:(ncol(werte) - 1))) {
                    faktor <- length(intersect(beste[j, 1, i]:beste[j, 
                      2, i], beste[k, 1, i]:beste[k, 2, i]))/length(beste[j, 
                      1, i]:beste[j, 2, i])
                    zaehler <- zaehler + faktor * (ncol(werte) - 
                      j)^length_penalty
                  }
                }
                zaehler * log(j)
            }
            beste[(ncol(werte) - 1):1, 3, i] <- sapply((ncol(werte) - 
                1):1, gib_beste)
            kand <- max(beste[, 3, i])
            kuerzere <- which((kand - beste[, 3, i]) <= 0)
            winner <- beste[min(kuerzere), 3, i]
            if (length(beste[beste[, 3, i] == winner, 1:2, i]) == 
                2) {
                intervalle[, i] <- beste[min(kuerzere), c(1:2, 
                  4), i]
            }
            sperre <- union(sperre, (intervalle[1, i]):(intervalle[2, 
                i]))
            if (intervalle[1, i] == 0 & intervalle[2, i] == 0) {
                intervalle <- intervalle[, 1:(i - 1)]
                break
            }
        }
        intervalle <- as.matrix(intervalle)
        gueltig <- which(intervalle[1, ] != 0)
        gib_relevant <- function(p) {
            relevant(intervalle[1, p], intervalle[2, p], intervalle[3, 
                p])
        }
        auswahl_werte <- sapply(1:length(gueltig), gib_relevant)
        raus1 <- raus2 <- logical(ncol(intervalle))
        enthalten_werte <- numeric(ncol(intervalle))
        raus1[which(auswahl_werte < min_prop)] <- TRUE
        if (ncol(intervalle) >= 1) {
            gib_enthalten <- function(h) {
                enthalten(intervalle[1, h], intervalle[2, h], 
                  intervalle[3, h])
            }
            enthalten_werte <- sapply(1:ncol(intervalle), gib_enthalten)
        }
        raus2[enthalten_werte < min_med_num] <- TRUE
        if (any(raus1 | raus2)) {
            regionen <- as.matrix(intervalle[, -which(raus1 | 
                raus2)])
        }
        else {
            regionen <- as.matrix(intervalle)
        }
        regionen <- as.matrix(regionen)
        if (ncol(regionen) >= 2) {
            geaendert <- 1
            while (geaendert == 1) {
                for (i in c(1:ncol(regionen), ncol(regionen))) {
                  if (i == 1) {
                    geaendert <- 0
                  }
                  band1 <- regionen[2, i]:(regionen[2, i] + combine_near)
                  band2 <- (regionen[1, i] - combine_near):regionen[1, 
                    i]
                  if (any(regionen[1, 1:(i - 1)] %in% band1)) {
                    dings1 <- which(regionen[1, ] == band1[which(band1 %in% 
                      regionen[1, -i])])
                    ersetz1 <- regionen[2, dings1[length(dings1)]]
                    if (length(ersetz1) > 0 && (regionen[3, i] == 
                      regionen[3, dings1[length(dings1)]])) {
                      regionen[2, i] <- ersetz1
                      geaendert <- 1
                    }
                  }
                  if (any(regionen[2, 1:(i - 1)] %in% band2)) {
                    dings2 <- which(regionen[2, ] == band2[which(band2 %in% 
                      regionen[2, -i])])
                    ersetz2 <- regionen[1, dings2[length(dings2)]]
                    if (length(ersetz2) > 0 && (regionen[3, i] == 
                      regionen[3, dings2[length(dings2)]])) {
                      regionen[1, i] <- ersetz2
                      geaendert <- 1
                    }
                  }
                }
            }
        }
        regionen <- as.matrix(regionen)
        if (ncol(regionen) >= 1) {
            raus3 <- logical(ncol(regionen))
            raus3[regionen[2, ] - regionen[1, ] < eliminate_short] <- TRUE
            if (any(raus3)) {
                regionen <- regionen[, -which(raus3)]
            }
        }
        regionen <- as.matrix(regionen)
        if (ncol(regionen) > 1) {
            breite <- function(i) {
                regionen[2, i] - regionen[1, i]
            }
            regionenbreite <- sapply(1:ncol(regionen), breite)
            regionen <- regionen[, sort(regionenbreite, index.return = TRUE, 
                decreasing = TRUE)$ix]
            regionen_output <- regionen[, 1]
            regionen <- regionen[, -1]
            regionen <- as.matrix(regionen)
            regionen_output <- as.matrix(regionen_output)
            for (i in 1:ncol(regionen)) {
                gib_drinodernicht <- function(j) {
                  if (regionen[1, i] >= regionen_output[1, j] && 
                    regionen[2, i] <= regionen_output[2, j]) {
                    return(1)
                  }
                  else {
                    return(0)
                  }
                }
                drinodernicht <- sapply(1:ncol(regionen_output), 
                  gib_drinodernicht)
                if (sum(drinodernicht) == 0) {
                  regionen_output <- cbind(regionen_output, regionen[, 
                    i])
                }
            }
            if (ncol(regionen_output) > 1) {
                regionen_output <- regionen_output[, sort(regionen_output[1, 
                  ], index.return = TRUE)$ix]
            }
            abnormality <- function(x) {
                if (x == 1) {
                  "increase"
                }
                else "reduction"
            }
            regionen_output[3, ] <- sapply(regionen_output[3, 
                ], abnormality)
            regionen_output <- data.frame(regionen_output)
            rownames(regionen_output) <- c("begin", "end", "abnormality")
            colnames(regionen_output) <- 1:ncol(regionen_output)
        }
        else {
            if (ncol(regionen) == 1) {
                regionen_output <- as.matrix(regionen[, 1])
                if (regionen_output[3, 1] == 1) {
                  regionen_output[3, 1] <- "increase"
                }
                else {
                  regionen_output[3, 1] <- "reduction"
                }
                regionen_output <- data.frame(regionen_output)
                rownames(regionen_output) <- c("begin", "end", 
                  "abnormality")
                colnames(regionen_output) <- 1
            }
            else {
                regionen_output <- NULL
            }
        }
        reg_out1 <- as.numeric(sapply(regionen_output[1, ], as.character))
        reg_out2 <- as.numeric(sapply(regionen_output[2, ], as.character))
        reg_out3_a <- sapply(regionen_output[3, ], as.character)
        konvert <- function(x) {
            if (x == "increase") {
                return(1)
            }
            if (x == "reduction") {
                return(3)
            }
        }
        reg_out3 <- sapply(as.vector(reg_out3_a), konvert)
        if (length(regionen_output) > 0) {
            gib_enthalten <- function(h) {
                enthalten(reg_out1[h], reg_out2[h], reg_out3[h])
            }
            enthalten_werte_end <- sapply(1:length(reg_out1), 
                gib_enthalten)
            gib_max_abstand_werte <- function(z) {
                max_abstand(reg_out1[z], reg_out2[z], reg_out3[z])
            }
            max_abstand_werte <- sapply(1:length(reg_out1), gib_max_abstand_werte)
        }
        else {
            enthalten_werte_end <- NULL
            max_abstand_werte <- NULL
        }
        RVAL <- list(regions_first_step = intervalle, proportions_first_step = auswahl_werte, 
            median_number_of_points_first_step = enthalten_werte, 
            regions_final = regionen_output, maximum_distance_final = max_abstand_werte, 
            median_number_of_points_final = enthalten_werte_end, 
            chromosome = chr1)
        RVAL
    }
    find_regions_here <- function(chr1) {
        find_regions_chr(results, chr1, resolution, level, length_penalty, 
            limit, min_prop, min_med_num, combine_near, eliminate_short, 
            num_regions)
    }
    RVAL2 <- sapply(chr, find_regions_here)
    attr(RVAL2, "dimnames") <- dimnames(RVAL2)
    attr(RVAL2, "resolution") <- resolution
    attr(RVAL2, "level") <- level
    attr(RVAL2, "length_penalty") <- length_penalty
    attr(RVAL2, "limit") <- limit
    attr(RVAL2, "min_prop") <- min_prop
    attr(RVAL2, "min_med_num") <- min_med_num
    attr(RVAL2, "combine_near") <- combine_near
    attr(RVAL2, "eliminate_short") <- eliminate_short
    attr(RVAL2, "num_regions") <- num_regions
    RVAL2
}
