plot.edira <-
function(x, type="test", chr=NULL, pch=18, cyto=TRUE, region_finder=FALSE, regions=NULL,
        legend=TRUE, ...){
    data(cytoband)
    if(type == "eccc"){
        werte <- x$eccc
        ylab <- expression(paste("Value of ", r[EC]))
    }
    if(type == "eccc_var"){
        werte <- x$eccc_var
        ylab <- expression(paste("Value of ", r[NEC]))
    }
    if(type == "test"){
        werte <- -log10(x$test)
        ylab <- "-log10(p-value of Wilcoxon test)"
    }
    q_ende <- cytoband$end[c((which(cytoband$start == 0)-1)[-1],length(cytoband$end))]/10^6
    par(pch=pch, mar=c(4, 4.5, 2, 2) + 0.1, cex.lab=1.3, cex.main=1.3, cex.axis=1.5)
    if(length(chr) == 0){
        p_arm <- c(0,cumsum(as.numeric(q_ende)))
        liste <- strsplit(cytoband$name,"")
        giberstes <- function(x){x[1]}
        pq <- sapply(liste,giberstes)
        welche_q_1 <- c(0,which(pq == "q"))
        welche_q_2 <- which(pq == "q")
        differenz <- welche_q_2 - welche_q_1[-length(welche_q_1)]
        q_arm_einzeln <- cytoband$start[welche_q_2[differenz > 1]]/10^6
        q_arm <- q_arm_einzeln + p_arm[1:22]
        anf <- numeric(22)
        for(i in 1:22){anf[i] <- range(which(x$chromosome == i))[1]}
        xwerte <- x$position/10^6
        for(m in 2:22){xwerte[which(x$chromosome == m)] <- xwerte[which(x$chromosome == m)] + p_arm[m]}    
        xspannw <- c(0,p_arm[22])+c(75,-25)
        yspannw <- range(werte) 
        plot(xwerte[which(x$quadrant == 2)], werte[which(x$quadrant == 2)], col="blue", xlab="", ylab="", xlim=xspannw, ylim=yspannw)
        if(region_finder){
            nr <- as.numeric(unlist(regions[7,]))
            for(k in 1:length(nr)){
                if(length(regions[4,][[k]]) != 0){
                    for(l in 1:length(regions[4,][[k]])){
                        spannw <- p_arm[nr[k]] + as.numeric(as.character(regions[4,][[k]][,l][1:2]))
                        rect(xleft=spannw[1],xright=spannw[2],ybottom=-1, ytop=11, col="yellow")
                    }
                }
            }
        }
        par(new=TRUE)
        plot(xwerte[which(x$quadrant == 2)], werte[which(x$quadrant == 2)], col="blue", xlab="", ylab="", xlim=xspannw, ylim=yspannw)
        par(new=TRUE)
        plot(xwerte[which(x$quadrant == 4)], werte[which(x$quadrant == 4)], col="orange", xlim=xspannw, xlab="", ylab="", ylim=yspannw)
        par(new=TRUE)
        plot(xwerte[which(x$quadrant == 1)], werte[which(x$quadrant == 1)], col="red", xlab="", ylab="", xlim=xspannw, ylim=yspannw)
        par(new=TRUE)
        plot(xwerte[which(x$quadrant == 3)], werte[which(x$quadrant == 3)], col="black", xlab="Position (MBp) on the chromosomes", ylab=ylab, xlim=xspannw, ylim=yspannw)
        abline(v=p_arm, lty="dashed", lwd=3)
        abline(v=q_arm, lty="dotted", lwd=3)
        par(las=2, cex.axis=0.7)
        berechne_mittel <- function(x){mean(c(p_arm[x],p_arm[x-1]))}
        chr_mittel <- sapply(2:length(p_arm),berechne_mittel)
        axis(side=3, at=chr_mittel, labels=1:22, tick=FALSE, pos=max(werte)+0.03*(range(werte)[2]-range(werte)[1]), cex.axis=1.2, las=0)
        par(las=0, cex.axis=1)
    } else {
        welche <- which(x$chromosome == chr)
        xwerte <- x$position[welche]/10^6
        diese <- werte[welche]
        quadrant <- x$quadrant[welche]
        xspannw <- c(0,q_ende[chr])
        xspannw <- xspannw+c(1,-1)*0.01*xspannw
        yspannw <- range(diese)
        plot(xwerte[x$quadrant == 2], diese[x$quadrant == 2], col="blue", xlab="", ylab="", xlim=xspannw, ylim=yspannw)
        if(region_finder){
                nr <- which(as.numeric(unlist(regions[7,])) == chr)
                if(length(regions[4,][[nr]]) != 0){
                    for(l in 1:length(regions[4,][[nr]])){
                        spannw <- as.numeric(as.character(regions[4,][[nr]][,l][1:2]))
                        rect(xleft=spannw[1],xright=spannw[2],ybottom=-1, ytop=11, col="yellow")
                    }
                }
        }
        par(new=TRUE)
        plot(xwerte[x$quadrant[welche] == 2], diese[x$quadrant[welche] == 2], col="blue", xlab="", ylab="", xlim=xspannw, ylim=yspannw)
        par(new=TRUE)
        plot(xwerte[x$quadrant[welche] == 4], diese[x$quadrant[welche] == 4], col="orange", xlab="", ylab="", xlim=xspannw, ylim=yspannw)
        par(new=TRUE)
        plot(xwerte[x$quadrant[welche] == 1], diese[x$quadrant[welche] == 1], col="red", xlab="", ylab="", xlim=xspannw, ylim=yspannw)
        par(new=TRUE)
        plot(xwerte[x$quadrant[welche] == 3], diese[x$quadrant[welche] == 3], col="black", xlab=paste("Position (MBp) on chromosome", chr), ylab=ylab, xlim=xspannw, ylim=yspannw)        
        if(cyto){
            cb <- subset(cytoband, chromosome==chr)   
            abline(v=c(0,q_ende[chr]), lty="dashed", lwd=3)
            abline(v=cb$start/10^6, lty="dotted", lwd=2)
            par(las=2, cex.axis=0.7)
            axis(side=3, at=cb$start/10^6, labels=cb$name, tick=FALSE, pos=max(diese)+0.01*(range(diese)[2]-range(diese)[1]))
            par(las=0, cex.axis=1.5)
        }
        
    }
    if(legend){legend(locator(1),legend=c("I","II","III","IV"), fill=c("red", "blue", "black", "orange"), bg="white") }
}
