segmentCN <-
function (X, Y_annot, chrs = 1:22, algorithm = "CBS", penalty = "BIC", 
    maxseg = 50, estseg = "mean", estval = "median", sort=TRUE) 
{   
    if(sort == TRUE){
        sorting_X_position <- sort(X$info$position,index.return=TRUE, method = "shell")$ix
        sorting_X_chromosome <- sort(X$info$chromosome[sorting_X_position],index.return=TRUE, method = "shell")$ix
        X$data <- X$data[sorting_X_position[sorting_X_chromosome],]
        X$info <- X$info[sorting_X_position[sorting_X_chromosome],]
        sorting_Y_position <- sort(Y_annot$position,index.return=TRUE, method = "shell")$ix
        sorting_Y_chromosome <- sort(Y_annot$chromosome[sorting_Y_position],index.return=TRUE, method = "shell")$ix
        Y_annot <- Y_annot[sorting_Y_position[sorting_Y_chromosome],]
    }
    x <- X$data    
    if (algorithm == "Huber") {
        require(tilingArray)
        segmentWerteHuber <- function(chr, pat) {
            x_chrausw <- subset(x, X$info$chromosome == chr)[, 
                pat]
            Loglik <- -Inf
            seg <- EdiraSegment(x_chrausw, maxseg = maxseg, maxk = length(x_chrausw), 
                estseg = estseg)
            Loglik <- logLik(seg, penalty = penalty)
            Loglik_ohneNA <- Loglik[is.na(Loglik) == FALSE]
            anzseg <- which(Loglik == max(Loglik_ohneNA))
            ind <- c(1, as.numeric(seg@breakpoints[[anzseg]]), 
                length(x_chrausw))
            mw <- numeric(length(ind) - 1)
            if (estval == "median") {
                mittelw <- function(i) {
                  median(x_chrausw[ind[i]:(ind[i + 1] - 1)])
                }
                mw <- sapply(1:length(mw), mittelw)
            }
            if (estval == "mean") {
                mittelw <- function(i) {
                  mean(x_chrausw[ind[i]:(ind[i + 1] - 1)])
                }
                mw <- sapply(1:length(mw), mittelw)
            }
            pos_y <- Y_annot$position[Y_annot$chromosome == chr]
            pos_x <- X$info$position[X$info$chromosome == chr]
            daten <- numeric(length(pos_y))
            for (j in 1:(length(mw))) {
                welche <- which(pos_y >= pos_x[ind[j]] & pos_y < 
                  pos_x[ind[j + 1]])
                daten[welche] <- mw[j]
            }
            laenge_pos_y_Vor1 <- length(which(pos_y < pos_x[1]))
            if (laenge_pos_y_Vor1 > 0) {
                daten[1:laenge_pos_y_Vor1] <- mw[1]
            }
            laenge_pos_y_VorLetzt <- length(which(pos_y > pos_x[length(pos_x)]))
            letzte <- which(pos_y > pos_x[length(pos_x)])[1]
            if (laenge_pos_y_VorLetzt > 0) {
                daten[letzte:length(daten)] <- mw[length(mw)]
            }
            daten[length(daten)] <- mw[length(mw)]
            daten
        }
        output <- matrix(numeric(sum(Y_annot$chromosome %in% chrs) * (ncol(x))), 
            nrow = sum(Y_annot$chromosome %in% chrs))
        for (chr in chrs) {
            segment_patient <- function(pat) {
                segmentWerteHuber(chr, pat)
            }
            output[Y_annot$chromosome == chr, 1:ncol(x)] <- sapply(1:ncol(x), 
                segment_patient)
        }
        out <- data.frame(output)
    }
    if(algorithm == "CBS"){
    require(DNAcopy)
        CNA <- CNA(genomdat=x, chrom=X$info$chromosome, maploc=X$info$position, data.type="logratio",sampleid=1:ncol(x))
        smoothed.CNA <- smooth.CNA(CNA)
        segment.smoothed.CNA <- DNAcopy::segment(smoothed.CNA, verbose=0)

        samples_liste <- strsplit(segment.smoothed.CNA$output$ID, split="X")
        nehme_2 <- function(x){
            x[2]
        }
        samples <- as.numeric(lapply(samples_liste, nehme_2))
        chromosome <- segment.smoothed.CNA$output$chrom
        #out <- 
        
        segmentWerteCBS <- function(chr, pat){
        welcheY <- which(Y_annot$chromosome == chr)
        welcheX <- which(samples == pat & chromosome == chr)
            giveSegment <- function(w){
              segmente_links <- which(segment.smoothed.CNA$output$loc.start[welcheX] <= Y_annot$position[welcheY][w])
              if(length(segmente_links) == 0){ segmente_links <- 1 }
              segment <- segmente_links[length(segmente_links)]
              welcheX[segment]      
            }
        segment_ind <- sapply(1:length(welcheY),giveSegment)
        segment.smoothed.CNA$output$seg.mean[segment_ind]
        }
        #out[welcheY,pat]
        
        output <- matrix(numeric(sum(Y_annot$chromosome %in% chrs)*(ncol(x))), nrow=sum(Y_annot$chromosome %in% chrs))
        for(pat in 1:ncol(x)){
            segment_patient <- function(chr){segmentWerteCBS(chr,pat)}
            output[,pat] <- unlist(sapply(chrs, segment_patient))
        }
    out <- data.frame(output)
    }
    colnames(out) <- c(1:ncol(x))
    info <- as.data.frame(cbind(Y_annot$chromosome[Y_annot$chromosome %in% chrs],Y_annot$position[Y_annot$chromosome %in% chrs]))
    colnames(info) <- c("chromosome", "position")
    list(data = out, info = info)
}
