\name{AMLdata}
\alias{CN}
\alias{CN_ref}
\alias{CN_segmented}
\alias{CN_ref_segmented}
\alias{GE}
\alias{GE_ref}
\alias{AMLdata}
\docType{data}
\title{Acute Myeloid Leukemia Data}
\description{
Gene expression (GE) and copy number (CN) data for chromosomes 4-7 from 25 patients suffering acute myeloid leukemia with a complex aberrant karyotype,
coresponding gene expression data from eleven healthy individuals and copy number data from two healthy individuals.
}
\usage{data(AMLdata)}
\format{
  \code{CN_data} and \code{CN_ref_data} are data frames with 2602 and 2500 rows, respectively, each row representing a probe set of the Affymetrix Mapping 10K 2.0 SNP Array.
  \code{CN_data_segmented},\code{CN_ref_data_segmented}, \code{GE_data} and \code{GE_ref_data} are data frames with 2687 rows, each row representing a probe set of the
  Human Genome U133 A/B Array Set. \code{GE_data} and \code{GE_ref_data} contain gene expression intensities, the other data frames contain copy number intensities.
  Each data frame contains one column for the data of each individual, in addition to the following two columns:
  \describe{
    \item{\code{chromosome}}{chromosome number for each probe set.}
    \item{\code{position}}{middle position for each probe set.}
  }
}
\details{
All data sets have been preprocessed as described in Schaefer et al. (2009).
\code{CN_data_segmented} and \code{CN_ref_data_segmented} contain the data from \code{CN_data} and \code{CN_ref_data} after performing segmentation
by use of \code{segmentCN} with \code{algorithm="Huber"}, assigning to each probe set contained in \code{GE_data} and \code{GE_ref_data} a copy number intensity.
}
\source{
Merk, S., Klein, H.-U., Haferlach, C., and Dugas, M. (2007). Visualization and combined
analysis of SNP and gene expression data with Rcnat. Poster, CAMDA Critical
Assessment of Microarray Data Analysis 2007 Conference, Valencia.
}
\references{
Schaefer, M., Schwender, H., Merk, S., Haferlach, C., Ickstadt, K., Dugas, M. (2009), Integrated analysis of copy number alterations and gene expression:
A bivariate assessment of equally directed abnormalities, Bioinformatics 25(24), 3228  3235.
}
\examples{\dontrun{
data(AML_data)
str(GE_data)
}}
\keyword{datasets}
