\name{EdiraCostMatrix}
\alias{EdiraCostMatrix}

\title{
Segmentation cost matrix
}

\description{
This function is a modified version of the \code{costMatrix} function used by Huber et al. in the package \code{\link{tilingArray}} to calculate the cost matrix for the segmentation model.
It allows to use the median instead of the mean as estimator for the raw copy number of a segment in calculating the residual sum of squares cost function.
It is called by \code{segmentCN} and not intended for handling by the user!
}

\usage{
EdiraCostMatrix(x, maxk, estseg)
}

\arguments{
  \item{x}{numeric vector.}
  \item{maxk}{positive integer.}
  \item{estseg}{estimator for the constant copy number intensities used for the calculation the residual sum of squares criterion. Currently, \code{estseg="mean"} and \code{estseg="median"} are supported.}
}

\references{
Huber, W., Toedling, J., Steinmetz, L. (2006), Transcript mapping with high-density oligonucleotide tiling arrays, Bioinformatics 22, 1963-1970.
}

\author{
Martin Schaefer, based on code from W. Huber
}

\seealso{
\code{\link{segmentCN},\link{EdiraSegment} }
}

\keyword{manip}
\keyword{datagen}
\keyword{methods}
