\name{EdiraSegment}
\alias{EdiraSegment}

\title{
Fit a piecewise constant curve: segmentation by dynamic programming
}

\description{
This function is almost identical to the \code{segment} function used by Huber et al. in the package \code{\link{tilingArray}} and allows for more flexibility in calculating the cost matrix for the segmentation model.
It is called by \code{segmentCN} and not intended for handling by the user!
}

\usage{
EdiraSegment(y, maxseg, maxk, estseg)
}

\arguments{
  \item{y}{numeric vector containing data to be segmented. Breakpoints are fitted along the x-axis. For example, the x-variable can be genomic coordinates or time.}
  \item{maxseg}{maximum number of segments to try and fit.}
  \item{maxk}{maximum number of data points per segments, set to the length of \code{y} by \code{segmentCN}.}
  \item{estseg}{estimator for the constant copy number intensities between breakpoints used in the estimation of the segment breakpoints via the residual sum of squares criterion. Currently, \code{estseg="mean"} and \code{estseg="median"} are supported.}
}

\references{
Huber, W., Toedling, J., Steinmetz, L. (2006), Transcript mapping with high-density oligonucleotide tiling arrays, Bioinformatics 22, 1963-1970.
}

\author{
Martin Schaefer, based on code from W. Huber
}

\seealso{
\code{\link{segmentCN},\link{EdiraCostMatrix} }
}

\keyword{manip}
\keyword{datagen}
\keyword{methods}
