\name{cytoband}
\alias{cytoband}
\docType{data}
\title{Cytoband Information}
\description{
Cytoband definitions from the UCSC genome annotation database (hg18).
}
\usage{data(cytoband)}
\format{
  A data frame containing information on 811 cytobands in the following 4 variables.
  \describe{
    \item{\code{chromosome}}{a numeric vector containing the chromosome number (1-22). Analysis for X and Y chromosomes is not supported currently.}
    \item{\code{start}}{a numeric vector containing the start position of the cytoband.}
    \item{\code{end}}{a numeric vector containing the end position of the cytoband.}
    \item{\code{name}}{a character vector containing the name of the cytoband.}
  }

  The cytobands are sorted according to their position.
}
\details{
\code{cytoband} is called by \code{\link{find_regions}} and \code{\link{plot.edira}}.
}
\source{
  http://hgdownload.cse.ucsc.edu/goldenPath
}
\references{
Karolchik, D., Kuhn, R.M., Baertsch, R., Barber, G.P., Clawson, H., Diekhans, M., Giardine, B., Harte, R.A., Hinrichs, A.S., Hsu, F., Miller, W.,
Pedersen, J.S., Pohl, A., Raney, B.J., Rhead, B., Rosenbloom, K.R., Smith, K.E., Stanke, M., Thakkapallayil, A., Trumbower, H., Wang, T.,
Zweig, A.S., Haussler, D., Kent, W.J.(2008): The UCSC Genome Browser Database: 2008 update. Nucleic Acids Res. 36:D773-9.
}
\examples{\dontrun{
data(cytoband)
str(cytoband)
}}
\keyword{datasets}
